;;; $Id: ch3-1-modified-in-class.tst,v 1.2 2006/10/20 15:38:55 leavens Exp $
;;; Test cases for the 3-1 interpreter modified in class

(require (lib "ch3-1-modified-in-class.scm" "lib342"))

(run-regression-tests-equal?
 `(
    ( (run "zero")
      ==> 0 )
    ( (run "+(zero, one)")
      ==> 1 )
    ( (run "/(25, 5)")
      ==> 5 )
    ( (run "/(342, one)")
      ==> 342 )
    ( (run "if 0 then 99 else 72")
      ==> 72 )
    ( (run "if one then 99 else 72")
      ==> 99 )
    ( (run "unless one do /(3,0)")
      ==> 0 )
    ( (run "unless zero do 22")
      ==> 22 )
    ( (run "unless +(3,4) do +(zero, +(7,8))")
      ==> 0 )
    ( (run "unless -(7,+(3,4)) do +(zero, +(7,8))")
      ==> 15 )
    ( (run "let x = 3 in *(x,x)")
      ==> 9 )
    ( (run "let x = 5  y = 6 in +(x,y)")
      ==> 11 )
    ( (run "let x = 3 in let x = *(x,x) in +(x,x)")
      ==> 18 )
    ( (run "let x = 3 in +(x, zero)")
      ==> 3 )
    ( (run "/(if +(zero, one) then let x = 3 in *(x,x) else x, one)")
      ==> 9 )
    ( (run "let x = 3 in let y = x in +(x,y)")
      ==> 6 )
    ( (run "seq-let x = 3 in +(x, zero)")
      ==> 3 )
    ( (run "seq-let x = 3 y = x in +(x,y)")
      ==> 6 )
    ))
