;;; $Id: environment-as-ast.scm,v 1.2 2005/12/22 05:06:01 leavens Exp $

;;; From EOPL2e, p. 60

(module environment-as-ast (lib "typedscm.ss" "typedscm")

(provide empty-env extend-env apply-env)

(deftype empty-env (-> () environment))
(deftype extend-env
  (-> ((list-of symbol) (list-of datum) environment) environment))
(deftype apply-env
  (-> (environment symbol) datum))

(require (lib "list-index-find.scm" "lib342"))

(define-datatype environment environment? 
  (empty-env)             
  (extend-env
    (syms (list-of symbol?))
    (vals (list-of datum?))
    (env environment?)))

(define apply-env
  (lambda (env sym)
    (cases environment env
      (empty-env ()
        (eopl:error 'apply-env "No binding for ~s" sym))
      (extend-env (syms vals env)
        (let ((pos (list-index sym syms)))
          (if (<= 0 pos)
            (list-ref vals pos)
            (apply-env env sym)))))))

) ;; end module
