;;; $Id: fix-mod.scm,v 1.2 2006/01/05 22:24:09 leavens Exp $

(module fix-mod (lib "typedscm.ss" "typedscm")

(provide fix Y)

;;; The following is quite useful for taking fixed points in Scheme,
;;; even though it's defined recursively, and so it's not a combinator.
;;; See the file y.scm for the usual fix-point combinators.
;;; Note that fix can handle multiple-argument functions.
(deftype fix
  (forall (S T) (-> ((-> ((-> (S ...) T)) (-> (S ...) T)))
                    (-> (S ...) T))))
(define fix
  (lambda (G)
    (lambda args
      (apply (G (fix G)) args))))

(define Y
  (lambda (G)
    (lambda args
      (apply (fix G) args))))

) ;; end module
