;;; $Id: road-map-as-ast.scm,v 1.4 2006/02/06 08:07:05 leavens Exp $

;;; The road-map abstraction is a concrete version of undirected graphs.
;;; Think of roads as things that cars drive on...

(module road-map-as-ast (lib "typedscm.ss" "typedscm")

(provide bare-earth build-road roads-from
        ;; all-from set-ops-as-vector.scm
        the-empty-set set-empty? set-size set set-member?
        set-one-elem set-rest set-subset? set-equal? set-add set-remove
        set-union set-minus set-intersect set-union-list set-union*)

(deftype bare-earth (-> () road-map))
(deftype build-road (-> (symbol symbol road-map) road-map))
(deftype roads-from (-> (road-map symbol) (set-of symbol)))

(require (lib "set-ops-as-vector.scm" "lib342"))

(define-datatype road-map road-map?
  (bare-earth)
  (build-road (from symbol?) (to symbol?) (old-map road-map?)))

(define roads-from
  (lambda (rmap place)
    (cases road-map rmap
      (bare-earth () the-empty-set)
      (build-road (from to old-map)
        (cond
         ((eq? place from) (set-add to (roads-from old-map place)))
         ((eq? place to) (set-add from (roads-from old-map place)))
         (else (roads-from old-map place))))
      )))

) ; end module
