;;; $Id: separate.scm,v 1.3 2006/01/05 22:24:09 leavens Exp $

(module separate (lib "typedscm.ss" "typedscm")

  (provide separate-c comma-separate blank-separate
           semicolon-separate binding-separate)
  
  (deftype separate-c (-> (string) (-> ((list-of string)) string)))
  (define separate-c
    (lambda (sep)
      (lambda (args)
        (cond
         ((null? args) "")
         ((null? (cdr args)) (car args))
         (else (string-append (car args)
                              sep
                              ((separate-c sep) (cdr args))))))))

  (define comma-separate (lambda (args) ((separate-c ", ") args)))
  (define blank-separate (lambda (args) ((separate-c " ") args)))
  (define semicolon-separate (lambda (args) ((separate-c "; ") args)))
  (define binding-separate (lambda (args) ((separate-c "  ") args)))

) ;; end module
