;;; $Id: statement-expression.tst,v 1.2 2006/01/05 22:24:09 leavens Exp $

(require (lib "statement-expression.scm" "lib342"))

(run-regression-tests-equal?
 `(

   ( (parse-statement 'x) = (exp-stmt (var-exp 'x)) )
   ( (parse-statement 3) = (exp-stmt (num-exp 3)) )
   ( (parse-statement '(set! x 3)) = (set-stmt 'x (num-exp 3)) )
   ( (parse-statement '(begin (set! x 3) x))
     = (exp-stmt (begin-exp (list (set-stmt 'x (num-exp 3))) (var-exp 'x))) )

   ( (statement? (parse-statement '(begin (set! x 3) x))) ==> #t )

   ( (expression? (parse-statement '(begin (set! x 3) x))) ==> #f )
   ( (expression? (parse-expression '(begin (set! x 3) x))) ==> #t )
   ( (expression? (parse-expression '(begin (set! y 4) (set! x 3) x))) ==> #t )

   ( (parse-expression '(begin x))
     = (begin-exp '() (var-exp 'x)) )
   ( (parse-expression '(begin (set! y 4) (set! x 3) x))
     = (begin-exp (list (set-stmt 'y (num-exp 4)) (set-stmt 'x (num-exp 3)))
                  (var-exp 'x)) )
   ( (expression? (parse-expression '(begin (set! y 4) (begin (set! x 3) x))))
     ==> #t )

   ( (begin-exp? (parse-expression '(begin x))) ==> #t )

   ( (var-exp? (parse-expression '(begin x))) ==> #f )
   ( (var-exp? (parse-expression 'x)) ==> #t )

   ( (num-exp? (parse-expression 3)) ==> #t )

   ( (exp-stmt? (parse-statement 3)) ==> #t )

   ( (set-stmt? (set-stmt 'x (num-exp 3))) ==> #t )

   ( (set-stmt->id (set-stmt 'x (num-exp 3))) ==> x )
   ( (set-stmt->exp (set-stmt 'x (num-exp 3)))
     = (num-exp 3) )

   ( (exp-stmt->exp (exp-stmt (num-exp 3)))
     = (num-exp 3) )

   ( (num-exp->num (num-exp 3)) ==> 3 )

   ( (var-exp->id (var-exp 'x)) ==> x )

   ( (begin-exp->stmts (parse-expression '(begin x)))
     = '() )
   ( (begin-exp->exp (parse-expression '(begin x)))
     = (var-exp 'x) )

    )
 )
