;;; $Id: sym-exp-tests.scm,v 1.3 2006/01/05 22:24:09 leavens Exp $

(module sym-exp-tests (lib "typedscm.ss" "typedscm")

(provide run-tests)

(define run-tests
  (lambda ()
    (run-regression-tests-equal?
     `(
       ( (sym-exp? (s-list '())) ==> #t )
       ( (sym-exp? (symbol 'zzyggy)) ==> #t )
       ( (sym-exp? 1) ==> #f )
       ( (sym-exp? (parse-sym-exp 'x)) ==> #t )
       ( (sym-exp? (parse-sym-exp '(x y () (z) ((()))))) ==> #t )

       ( (s-list? (sym-exp->s-list (s-list '()))) ==> #t )
       ( (s-list? (list (s-list '()) (symbol 'zz))) ==> #t )
       ( (s-list? '()) ==> #t )
       ( (s-list? 'x) ==> #f )
       ( (s-list? (parse-s-list '(x))) ==> #t )
       ( (s-list? (parse-s-list '(x y () (z) ((()))))) ==> #t )

       ( (sym-exp-symbol? (symbol 'x)) ==> #t )
       ( (sym-exp-symbol? (s-list '())) ==> #f )
       ( (sym-exp-symbol? (s-list (list (symbol 'y)))) ==> #f )

       ( (sym-exp-s-list? (symbol 'x)) ==> #f )
       ( (sym-exp-s-list? (s-list '())) ==> #t )
       ( (sym-exp-s-list? (s-list (list (symbol 'y)))) ==> #t )

       ( (sym-exp->symbol (symbol 'x)) ==> x )
       ( (sym-exp->s-list (s-list '())) ==> () )
       ( (sym-exp->symbol (car (sym-exp->s-list
                                (s-list (list (symbol 'y))))))
         ==> y )
       )
     )
    ))

) ;; end module
