;;; $Id: window-layout-mod.tst,v 1.1 2006/01/17 18:14:52 leavens Exp $

(require (lib "window-layout-mod.scm" "lib342"))

(define complex-layout
       (parse-window-layout
        '(horizontal
            (vertical (window tempest 200 100)
                      (window othello 200 77)
                      (window hamlet 1000 600))
            (horizontal (window baseball 50 40)
                        (window track 100 60)
                        (window equesterian 70 30))
            (vertical (window star-trek 40 100)
                      (window olympics 80 33)
                      (window local-news 20 10)))))

(run-regression-tests-equal?
 `(

   ( (window-layout? (parse-window-layout '(window olympics 80 33)))
      ==> #t )
   ( (window? (parse-window-layout '(window olympics 80 33)))
      ==> #t )
   ( (window-layout? (parse-window-layout
                      '(horizontal )))
      ==> #t )
   ( (horizontal? (parse-window-layout
                      '(horizontal (window olympics 10 20)
                                   (window local-news 20 10))))
      ==> #t )
   ( (window-layout? (parse-window-layout
                      '(vertical )))
      ==> #t )
   ( (vertical? (parse-window-layout
                      '(vertical (window olympics 10 20)
                                 (window local-news 20 10))))
      ==> #t )
   ( (window-layout? complex-layout)
     ==> #t )
   ( (window->name (parse-window-layout '(window olympics 80 33)))
      ==> olympics )
   ( (window->width (parse-window-layout '(window olympics 80 33)))
      ==> 80 )
   ( (window->height (parse-window-layout '(window olympics 80 33)))
      ==> 33 )
   ( (horizontal->subwindows
      (parse-window-layout
       '(horizontal (window olympics 10 20)
                    (window local-news 20 10))))
      = (list (parse-window-layout '(window olympics 10 20))
              (parse-window-layout '(window local-news 20 10))) )
   ( (vertical->subwindows
      (parse-window-layout
       '(vertical (window olympics 10 20)
                  (window local-news 20 10))))
      = (list (parse-window-layout '(window olympics 10 20))
              (parse-window-layout '(window local-news 20 10))) )

    )
 )
